<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( "3\nIllegal access" );

define('NAGIOS_STATE_OK','0');
define('NAGIOS_STATE_WARNING','1');
define('NAGIOS_STATE_CRITICAL','2');
define('NAGIOS_STATE_UNKNOWN','3');
define('NAGIOS_STATE_DEPENDENT','4');

class JoomonitorController {
	var $login;
	var $password;
	var $allowedips;
	var $ignore;
	var $component_name;

	function JoomonitorController() {
		$this->component_name = 'com_joomonitor';
		
		// Get Parameters
		$componentParams = JFactory::getApplication('site')->getParams($this->component_name);
		$this->login = $componentParams->get('login', '');
		$this->password = $componentParams->get('password', '');

		// Clean allowed ips
		$t_ips = explode("\n", $componentParams->get('allowedips', ''));
		$t_ips = array_map('trim', $t_ips); // apply trim on each element
		$t_ips = array_filter($t_ips); // remove empty value
		$this->allowedips = $t_ips;

		// Format & clean update ignored list
		$t_ignore = explode("\n", $componentParams->get('ignore', '') );
		$t_ignore = array_map('trim', $t_ignore);
		$t_ignore = array_unique($t_ignore);
		$this->ignore = $t_ignore;
	}

	function do_action() {
		$jinput = JFactory::getApplication()->input;
		$action = trim( $jinput->post->get('jm_action', '', 'STRING') ); // action to do
		$element = trim( $jinput->post->get('jm_element', '', 'STRING') ); // element to proceed

		if ((!empty($element)) && (!empty($action))) {
			switch ($action) {
				case 'SUSPEND' :
					$this->ignore[] = $element;
					$this->ignore = array_unique($this->ignore);
					break;
				case 'TODO' :
					$key = array_search($element, $this->ignore);
					if ($key !== FALSE) {
						unset( $this->ignore[$key] );
					}
					break;
				default :
					die('Invalid action.');
			}
			$params = JFactory::getApplication('site')->getParams($this->component_name);
			//$params = JComponentHelper::getParams($this->component_name);
			
			// Set the new 'ignore' values
			$params->set('ignore', implode("\n", $this->ignore ));

			//// Save the new parameters batch ////
			$db = JFactory::getDBO();
			$query = $db->getQuery(true);
			$query->update('#__extensions AS a');
			$query->set('a.params = ' . $db->quote((string)$params));
			$query->where('a.element = "'.$this->component_name.'"');
			$db->setQuery($query);
			$db->query();
			echo "$action / $element";
			return true;
		}
		return false;
	}

	function check_auth() {
		// IP verification
		if ((!empty($this->allowedips)) && (!in_array( $_SERVER['REMOTE_ADDR'], $this->allowedips))) {
			die("3\nAccess denied for ".$_SERVER['REMOTE_ADDR']);
		}

		// Get the (optionnal) posted login/pwd
		$jinput = JFactory::getApplication()->input;
		$username = trim( $jinput->post->get('jm_username', '', 'STRING') ); // element to proceed
		$password = trim( $jinput->post->get('jm_password', '', 'STRING') ); // element to proceed

		if (empty($username) || empty($password)) {
			if (isset($_SERVER['PHP_AUTH_USER'])) {
				$username = $_SERVER['PHP_AUTH_USER'];
			}
			if (isset($_SERVER['PHP_AUTH_PW'])) {
				$password = $_SERVER['PHP_AUTH_PW'];
			}
		}
		// Password verification
		if (($username != $this->login) || ($password != $this->password)) {
			header('WWW-Authenticate: Basic realm="Please authenticate"');
			header('HTTP/1.0 401 Unauthorized');
			die("3\nBad authentification.");
		}
                //bypass browser cross domain error if ip is trusted and login/password are correct
                header('Access-Control-Allow-Origin: *');
	} // check auth

	private function _getupdates() {
		$updater = JUpdater::getInstance();
		$jversion = new JVersion();

		if ($jversion->RELEASE == '2.5') {
			$options = array();
			$options['location']='';
			$options['update_site_id']='';
			$updater->findUpdates($options);
		} else {
			@$updater->findUpdates(0,0);
		}

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from('#__updates')->where('extension_id != 0');
		$db->setQuery($query);
		$updates = $db->loadObjectList();

		// Flag elements to ignore from the upgrades list
		$ret=array();
		foreach($this->ignore as $ignored_ext_version) {
			// Build initial ignored element array
			$ign = explode(' ', $ignored_ext_version);
			$ign_element = $ign[0];
			if (!empty($ign_element)) {
				if (isset($ign[1])) {
					$ign_version = $ign[1];
					$ign_fullname = $ign_element.' '.$ign_version;
					$ign_update_status = 'SUSPEND';
				} else {
					$ign_version = '';
					$ign_fullname = $ign_element;
					$ign_update_status = 'HOLD';
				}
				$ret[$ign_fullname] = array(
						'element'  => $ign_element,
						'version'  => $ign_version,
						'fullname' => $ign_fullname,
						'update_status'   => $ign_update_status,
						'existing_update'   => FALSE
					);
			}
		}
		foreach($updates as $key => $update){
			// Add elements with waiting updates
			if (array_search(trim($update->element), $this->ignore) !== FALSE) {
				//Remove an elements - HOLD -
				$update_status = 'HOLD';
			} elseif (array_search(trim($update->element.' '.$update->version), $this->ignore) !== FALSE) {
				//Remove an element for a specific version - SUSPEND -
				$update_status = 'SUSPEND';
			} else {
				//TO_UPDATE
				$update_status = 'TODO';
			}
			
			// Build returned array
			$ret[$update->element.' '.$update->version] = array(
					'element'  => $update->element,
					'version'  => $update->version,
					'fullname' => $update->element.' '.$update->version,
					'update_status'   => $update_status,
					'existing_update'   => TRUE
				);
				
			if (isset($ret[$update->element])) {
				//This element is already in the array (it must be a HOLD one), let's flag it
				$$ret[$update->element]['existing_update'] = TRUE;
			}
		}
		
		ksort($ret);
		$ret = array_values($ret);
		return $ret;
	}

	// Return an object with a lot of informations
	private function _getstatus() {
		$status = array();
		$status['ignore'] = $this->ignore;

		// Updates checking
		$jversion = new JVersion();
		$status['jversion'] = $jversion->RELEASE;

		$status['possible_updates'] = $this->_getupdates();
		$status['updates'] = array();
		foreach ($status['possible_updates'] AS $possible_update) {
			if ($possible_update['update_status'] == 'TODO') {
				$status['updates'][] = $possible_update['fullname'];
			}
		}

		$status['state'] = NAGIOS_STATE_UNKNOWN;
		if (count($status['updates']) == 0) {
			$status['state'] = NAGIOS_STATE_OK;
		} else {
			$status['state'] = NAGIOS_STATE_WARNING;
		}

		return $status;
	}

	function show_status() {
		$status = $this->_getstatus();
		$jinput = JFactory::getApplication()->input;
		$format = $jinput->get->get('format', 'nagios', 'STRING'); // nagios ou json
		switch (strtoupper($format)) {
			case "NAGIOS":
				$comment="";
				// Print ignore elements.
				if (count($status['updates'])) {
					$comment.= implode(', ', $status['updates']).'. ';
				}
				// Print ignore elements.
				if (count($status['ignore'])) {
					$comment.='Ignored element(s): '.implode(', ', $status['ignore']).'.';
				}

				echo $status['state']."\n".$comment;
				break;

			case "JSON":
				echo json_encode($status);
			break;

			default:
			die("Error: undefined format.");
		} // switch
	}

} // Class Joomonitor

?>
